require_dependency "defcon/application_controller"

module Defcon
	class SessionsController < ApplicationController
	  before_action :logged_in_check, only: [:destroy]
	  before_action :logged_out_check, only: [:new, :create]

	  def new
	  end

	  def create
	  	username = params[:username]
	  	if !username.nil?
	  		username = params[:username].downcase
	  	end
	    admin = ::Defcon::AdminUser.find_by(username: username)
	    if admin && admin.authenticate(params[:password]) && !admin.locked_out?
	    	admin.attempts = 0
	    	admin.save
	      session[:admin_id] = admin.id
	      session[:admin_username] = admin.username
	      flash[:notice] = "Welcome back!"
	      send_away
	    else
	    	if !admin.nil?
	    		admin.attempts = admin.attempts + 1
	    		admin.save
	    	end
	    	message = "Are you sure you belong here?"
	    	if !admin.nil? && admin.locked_out?
	    		message = "Locked out!"
	    	end
	    	flash[:alert] = message
	    	redirect_to defcon_login_path
	    end
	  end

	  def destroy
	    session[:admin_id] = nil
	    session[:admin_username] = nil
	    flash[:notice] = "Until next time!"
	    redirect_to defcon_login_path
	  end

	  private

	    def logged_in_check
	      if !::Defcon.logged_in?(session)
	      	flash[:alert] = "You are not logged in."
	        redirect_to defcon_login_path
	        return false
	      else
	        return true
	      end
	    end

	    def logged_out_check
	      if ::Defcon.logged_in?(session)
	      	flash[:alert] = "You are already logged in."
	        send_away
	        return false
	      else
	        return true
	      end
	    end

	    def send_away
	      begin
  				redirect_to main_app.admin_root_path
				rescue
  				redirect_to "/admin"
				end
	    end
	end
end
