module Defcon
  class AdminUser < ActiveRecord::Base
		has_secure_password
		
		validates :username, presence: true, :uniqueness => { :case_sensitive => false }
		validates :email, :uniqueness => { :case_sensitive => false }

		before_validation :set_defaults

		def locked_out?
			if self.max_attempts.nil?
  			return false
  		end
  		if self.attempts > self.max_attempts 
  			return true
  		else
  			return false
  		end
		end

		private

			def set_defaults
				if self.read_only.nil?
					self.read_only = false
				end
				if self.attempts.nil?
					self.attempts = 0
				end
				if self.master.nil?
					self.master = true
				end
				if self.priority.nil?
					self.priority = 0 
				end	
				if !self.username.nil?
					self.username = self.username.downcase
				end
				if !self.email.nil?
					self.email = self.email.downcase
				end
				return true
			end
  end
end
